%ext ck1

###GENERAL###

%version 1.1
%patchfile 0x131F8 regen.tli

%version 1.31
%patchfile 0x130F8 regen.tli

#Loading
%patch 0x014F1D "Loading a modification of Commander Keen part 1...    "

#Title position
%patch $97B2   $00 $00     # Y location, in pixels 
%patch $97B6   $04 $00     # (X location in pixels) / 8 + 4 

#Lives Keen has at game start
%patch $9000 $AAC6W $0000W #0 lives

#Skip Keens Left
%patch $7E99 $90 $90 $90 #Don't display box
%patch $7EBC $90 $90 $90 #Don't pause

#How fast tiles animate
%patch $7CDE $07 #In-game
%patch $9080 $07 #Main Menu level (Intro, title, story screen, etc.)

###PALETTE###

#Default palettes
%patch $15558  $00 $01 $02 $03 $04 $05 $06 $07  $18 $19 $1A $1B $1C $1D $1E $1F $03 #Black screen
%patch $15569  $00 $01 $02 $03 $04 $05 $06 $07  $18 $19 $1A $1B $1C $1D $1E $1F $03 #Fade 2 (Used by lights off too)
%patch $1557A  $00 $01 $02 $03 $04 $05 $06 $07  $18 $19 $1A $1B $1C $1D $1E $1F $03 #Fade 1
%patch $1558B  $00 $01 $02 $03 $04 $05 $06 $07  $18 $19 $1A $1B $1C $1D $1E $1F $03 #"Normal" colours

#This is the colour palette: 16 entries of r, g, b (each 0-63) 
%patch $13054 
       00 00 00 # black 
       00 00 42 # blue 
       00 42 00 # green 
       00 42 42 # cyan 
       42 00 00 # red 
       42 00 42 # magenta 
       42 21 00 # brown 
       42 42 42 # bright grey 
       21 21 21 # grey 
       00 00 63 # bright blue 
       00 63 00 # bright green 
       00 63 63 # bright cyan 
       63 00 00 # bright red 
       63 00 63 # pink 
       63 63 00 # yellow 
       63 63 63 # white 
#Set the palette when we go into graphics mode 
%patch $6E46  $E8 $D3 $D5 $90 $90 
#Code to set graphics mode and set the palette 
%patch $441C                  $B8 $0D $00 $CD 
              $10 $B8 $12 $10 $B9 $08 $00 $BB 
              $00 $00 $8C $DA $8E $C2 $BA $04 
              $00 $CD $10 $BB $18 $00 $BA $1C 
              $00 $CD $10 $C3 

###MAIN MENU###

#Number of menu items
%patch $9414 $07
%patch $938F $07

#Menu pointers
%patch $95ED $9570W # New Game
             $957FW # Story
             $9596W # High Scores
             $9589W # About ID...
             $95A3W # Ordering Info
             $95CAW # empty
             $95CAW # empty
             $95C2W # Restart Demo

#Simple Main Menu text patch
%patch $9625 $2E96W  $50 $E8 $CCA7W  $44 $44 $EB $46

#Menu text
%patch $15EE6 "   Start   " $0A
              "   English" $0A
              "   Unsere Besten" $0A
              "   Pionierlosung" $0A
              "   Weltspitze   " $0A
              "   " $0A
              "   " $0A
              "   Zurueck     " $0A $0A
              "Benutze " $00

#Extra text
%patch $15F6A "Pfeile" $00
%patch $15F71 "Maus " $00
%patch $15F77 "S-Hebel " $00
%patch $9686 $2F1AW #Arrows (Using keyboard)
%patch $968B $2F21W #Mouse (Using mouse)
%patch $9690 $2F27W #Joystick (Using joystick)

###TEXT SCREENS###

#Blank O.I text
%patch $A497 $C3

#Don't show sprites in O.I
%patch $A343 $EB $2E

#About ID is blank
%patch $97F0 $C3

#Locations of bitmaps in High Scores
%patch $987D $000FW #Horizontal position: High scores
%patch $988F $000DW #Horizontal position: Name
%patch $98A1 $001CW #Horizontal position: Score

#Don't show bitmaps in High Scores
%patch $98AA $EB $10 #Parts

#Where items are horizontally on each entry of the high score table
%patch $99EE $22 #Scores
%patch $9A03 $0D #Names

#Default score
%patch $7A12 $000AW #10

#Default high score names
%patch $1593F "ERICH    " $00
%patch $1594E "MARGOT   " $00
%patch $1595D "EGON     " $00

###MESSAGE WINDOWS###
#Quit windows
%patch $14DAB "ENDE (J/N)?" $00
%patch $085C $4A #'Yes' key
%patch $14DB8 "GEHE ZU (D)OS O." $0A $00
%patch $14DCA "(T)ITEL:" $00

#Sound window
%patch $0CC0 $000BW #Width
%patch $14DE1 "Ton (J/N)?" $00
%patch $0CEE $4A #'Yes' key

#Keyboard Commands window
%patch $156D8 "TASTATURBEFEHLE  " $0A $00
%patch $156EB "---------------  " $00
%patch $156FD $0A "0 Norden   :" $00
%patch $1570B $0A "1 Nordost  :" $00
%patch $15719 $0A "2 Osten    :" $00
%patch $15727 $0A "3 Suedost  :" $00
%patch $15735 $0A "4 Sueden   :" $00
%patch $15743 $0A "5 Suedwest :" $00
%patch $15751 $0A "6 Westen   :" $00
%patch $1575F $0A "7 Nordwest :" $00
%patch $1576D $0A "8 Knopf 1  :" $00
%patch $1577B $0A "9 Knopf 2  :" $00
%patch $15789 $0A " Was wird geaendert:" $00
%patch $1579F $0A $0D "     Neue Taste:" $00

#Jostick Configuration window
%patch $155A9 "  STEUERKNUEPPEL-KONFIG." $0A $00
%patch $155C4 "  ----------------------" $0A $00
%patch $155DF "Halte Hebel in der Ecke " $0A $00
%patch $155FA "oben links" $0A $00
%patch $15607 "und druecke den Knopf 1 : " $00
%patch $15622 $0A $0A "Halte Hebel in der Ecke " $0A $00
%patch $15640 "unt. rechts" $0A $00
%patch $1564E "und druecke den Knopf 1 : " $00

#High Score message
%patch $15E86 "        PUNKTE:" $00
%patch 0x015E9D " GRATULATION !  " 
%patch 0x015EB4 "PLATZ :" 
%patch 0x015B13 "1 -- " 
%patch 0x015B1A "2 --  " 
%patch 0x015B21 "3 -- " 
%patch 0x015B28 "4 --  " 
%patch 0x015B2F "5 -- " 
%patch 0x015B36 "6 -- " 
%patch 0x015B3D "7 --" 
%patch 0x015EBE "TOLL !" 
%patch 0x015EC7 " NAMEN EINGEBEN:"

#CTSpace cheat message
%patch $14DEE "Der kleine Eimer ist " $0A $00
%patch $14E05 "als Held der Arbeit ausge-" $0A $00               
%patch $14E21 "zeichnet worden. Mit  " $0A "" $00
%patch $14E39 "ALT huepft er vor Freude!" $00               

###F KEYS###

#Disable help text entirely
%patch $0C92 $90 $90

#Cannot save game
%patch $0D18 $EB $31

###STATUS WINDOW###

#Big versatile status window patch:
#Patch in the long-integer drawing function 
%patch $11B4                   $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF 
               $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8 
               $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A 
               $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 

#Status text file
%patch $13084  "STATUS.CK1" $00 

#Draw the status window
#Draw window of size 27x0A
%patch $0E6A                                           $B8 $00 $3D $BA $34 $00 
               $CD $21 $89 $C3 $BF $0027W  $C6 $06 $9A $82 $00 $B9 $000AW  $BA
               $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44 
               $5B $4F $75 $E8 $B4 $3E $CD $21

#Draw score
%patch $0E98                               $8B $46 $FE $05 $0001W  $50 $89 
               $F0 $05 $000AW  $50 $FF $36 $CC $AA $FF $36 $CA $AA $E8 $04 $03
               $83 $C4 $08 

#Hide extra Keen score
%patch $0EB3               $8B $46 $FE $05 $0013W  $50 $89 $F0 $05 $001AW  $50
               $A1 $C4 $6E $8B $16 $C2 $6E $81 $C2 $20 $4E $15 $00 $00 $50 $52
               $E8 $E1 $02 $83 $C4 $08

#Draw Keen's lives
%patch $0ED6                           $31 $FF $3B $3E $AAC6W  $7D $29 $83 $FF
               $06 $7D $24 $B8 $007BW  $50 $8B $46 $FE $05 $0003W  $B1 $03 $D3
               $E0 $90 $90 $50 $89 $F8 $D1 $E0 $05 $0001W  $01 $F0 $50 $E8 $2C
               $AC $83 $C4 $06 $47 $EB $D1

#Hide joystick
%patch $0F07                               $B8 $0141W  $83 $3E $AA94W  $00 $74
               $03 $B8 $01C0W  $50 $8B $46 $FE $05 $0013W  $B1 $03 $D3 $E0 $05
               $0004W  $50 $89 $F0 $05 $0010W  $50 $E8 $0D $AA $83 $C4 $06

#Hide battery
                                                                           $B8
               $0142W  $83 $3E $AA9CW  $00 $74 $03 $B8 $01C1W  $50 $8B $46 $FE 
               $05 $0013W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0013W
               $50 $E8 $E5 $A9 $83 $C4 $06

#Hide vacuum
                                           $B8 $0143W  $83 $3E $AA96W  $00 $74 
               $03 $B8 $01C2W  $50 $8B $46 $FE $05 $0013W  $B1 $03 $D3 $E0 $05 
               $0004W  $50 $89 $F0 $05 $0016W  $50 $E8 $BD $A9 $83 $C4 $06

#Hide whiskey
                                                                           $B8
               $0144W  $83 $3E $AA98W  $00 $74 $03 $B8 $01C3W  $50 $8B $46 $FE 
               $05 $0013W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0019W
               $50 $E8 $95 $A9 $83 $C4 $06

#Hide Key A
%patch $0FA7                               $B8 $0225W  $83 $3E $AA9EW  $00 $74
               $03 $B8 $01A8W  $50 $8B $46 $FE $05 $0013W  $B1 $03 $D3 $E0 $05 
               $0004W  $50 $89 $F0 $05 $0013W  $50 $E8 $6D $A9 $83 $C4 $06

#Hide Key B
                                                                           $B8
               $0225W  $83 $3E $AAA0W  $00 $74 $03 $B8 $01A9W  $50 $8B $46 $FE 
               $05 $0013W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0017W
               $50 $E8 $45 $A9 $83 $C4 $06

#Hide Key C
                                           $B8 $0225W  $83 $3E $AAA2W  $00 $74
               $03 $B8 $01AAW  $50 $8B $46 $FE $05 $0013W  $B1 $03 $D3 $E0 $05 
               $0004W  $50 $89 $F0 $05 $0013W  $50 $E8 $1D $A9 $83 $C4 $06

#Hide Key D
                                                                           $B8
               $0225W  $83 $3E $AAA4W  $00 $74 $03 $B8 $01ABW  $50 $8B $46 $FE 
               $05 $0013W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0017W 
               $50 $E8 $F5 $A8 $83 $C4 $06

#Hide Pogo
%patch $1047                               $B8 $000BW  $83 $3E $AA9AW  $00 $74
               $03 $B8 $019FW  $50 $8B $46 $FE $05 $0013W  $B1 $03 $D3 $E0 $05 
               $0004W  $50 $89 $F0 $05 $000BW  $50 $E8 $CD $A8 $83 $C4 $06

#Hide Ammo value
                                                                           $8B
               $46 $FE $05 $0013W  $50 $89 $F0 $05 $0005W  $50 $31 $C0 $50 $FF 
               $36 $AAC8W  $E8 $2E $01 $83 $C4 $08

#Draw Raygun
                                                   $B8 $0070W  $50 $8B $46 $FE
               $05 $0000W  $B1 $03 $D3 $E0 $05 $0000W  $50 $89 $F0 $05 $0010W
               $50 $E8 $95 $A8 $83 $C4 $06

#Wait for key and return
                                           $E8 $90 $4B $31 $C0 $50 $E8 $1E $AD
               $44 $44 $E8 $81 $A6 $E8 $D1 $F1 $E8 $CE $F1 $E8 $7C $4B $8B $46 
               $FC $8B $56 $FA $89 $16 $35 $51 $A3 $37 $51 $5F $5E $89 $EC $5D 
               $C3

###KEEN###

#Keen's spawn height
%patch $16E3 $0000W #No pixels down

#Keen's jump height in half tiles
%patch $3BAC $0000W

#Normal pogo height
%patch $4085 $0020W

#Never pogo high
%patch $3F32 $EB

#Keen shot height
%patch $46DC $00

#Keen shoot sound
%patch $3E33 $0A

#Disable sounds
%patch $3AA4 $EB $07 #Keen plummets off edges sound
%patch $3C3C $EB $07 #Keen jump sound
%patch $3D74 $EB $07 #Keen lands sound
%patch $4815 $EB $07 #Keen's shots hit walls sound
%patch $485E $EB $07 #Keen's shots hit sprites sound
%patch $AC5F $EB $0C #Keen blocked on map sound
%patch $AC64 $EB $07 #Keen walking on map sound
%patch $3E57 $EB $07 #Keen has no ammo sound
%patch $4749 $EB $07 #Keen's shot hits left wall and Keen sound
%patch $47BA $EB $07 #Keen's shot hits right wall and Keen sound

#Animations
%patch $39DC $0000W  #Facing left
%patch $3A0E $0000W  #Walking left
%patch $3ADA $08 $00 #Jumping right
%patch $3AE2 $08 $00 #Jumping left
%patch $3F7D $0018W  #Pogoing left
%patch $3B69 $0014W  #Shooting left (ctrl + alt: normal)
%patch $3C86 $0014W  #Shooting left (ctrl -> alt)
%patch $3DFF $0014W  #Shooting left (ctrl -> alt while jumping)
%patch $4034 $0014W  #Shooting left (alt -> ctrl while pogoing)
%patch $40E2 $0014W  #Shooting left (alt\ctrl at same time)

#Map Keen animations
%patch $AB85 $0024W #Moving up left
%patch $AB91 $0024W #Moving up
%patch $ABA2 $0024W #Moving up right
%patch $ABAE $0024W #Moving right
%patch $ABE8 $0024W #Moving left
%patch $ABFF $0000W #Frames used by all map sprites

###OTHER SPRITES###

#Yorp's spawn height
%patch $18A6 $0000W #No pixels down

#Yorp behaviour
%patch $18B4 $19D3W #When spawned
%patch $1980 $194FW #Do this randomly when walking

#Yorp speed
%patch $1A1C $FFF1W #If right of Keen after searching (Move left)
%patch $19C2 $FFF1W #If hits right wall (Move left)

#Yorp doesn't jump
%patch $1961 $EB

#Yorp animations
%patch $19E7 $0032W #Looking for Keen
%patch $19E4 $01    #And next frame
%patch $1993 $0030W #Walking right
%patch $199B $0032W #Walking left
%patch $19A5 $01    #And next frame

#Butler Robot speed
%patch $1E31 $FFFAW #If turned left (Move left)

#Butler Robot animations
%patch $17D0 $0058W #Start
%patch $1DDE $0058W #Walking left
%patch $1DE8 $00    #No next frame
%patch $1E87 $0058W #Turning
%patch $1E84 $00    #No next frame

#Tank Robot speed
%patch $1747 $0000W #Initial speed (Move right)
%patch $1F2B $0000W #Left speed
%patch $2019 $0000W #Right speed after shooting
%patch $2034 $0000W #Left speed after shooting

#Tank Robot shooting time
%patch $2012 $50 $7E

#Tank Robot shot moves l or r
%patch $490F $C7 $44 $20 $0000W $90

#Thank Robot shot moves u or d
%patch $490F $C7 $44 $22 $0190W $90

#Tank Robot shot collision
%patch $48E9 $0A $00

#Don't make Tank Robot fire sound
%patch $1FDB $EB $07

#Tank Robot shots hit sprites sound disabled
%patch $4A15 $EB $07

#Tank Robot animations
%patch $1EC0 $0062W #Walking left
%patch $1ECC $00    #No next frame
%patch $1FA7 $0062W #Turning
%patch $1FA4 $00    #No next frame

#Up right icecube speed
%patch $2110 $0000W #Up speed
%patch $2115 $00C8W #Right speed

#Up left icecube speed
%patch $2134 $0000W #Up speed
%patch $2139 $FF38W #Left speed

#Icecube collision
%patch $213E $22BBW

#Ice cannon shoot rate
%patch $2058 $06

#Ice cannon fire sound disabled
%patch $209A $EB $07


#Width of falling block




%patch $238D $0001W #Top left tile here
%patch $23F4 $0001W #Left end of ALL middle tiles
%patch $2465 $01    #Right end of block middle
%patch $2476 $0001W #Top right tile here

#Falling block tiles
%patch $24B6 $0001W #Top right
%patch $24D8 $0000W #Bottom right
%patch $2494 $0000W #Right left behind

#Number of fall cycles
%patch $24E8 $09

#Don't make falling block sound
%patch $2347 $90 $90 $90

#Chain doesn't kill Vorticons when shot
%patch $234C $5F $5E $5D $C3

#Don't make the border flash when Vorticon dies
%patch $1DAF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90

###COLLIDING BUTLER ROBOTS FINISH LEVEL###

#Rewrite tile routine to free up 15Kb
%patch $11F80 $06 $1E $50 $A1 $B2 $35 $8E $C0 $A1 $6A $83 $8E $D8 $A4 $A4 $03
              $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03
              $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03
              $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03
              $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $58 $1F $07
              $C3 $BA $2E $00 $66 $33 $C0 $8B $C3 $66 $8B $D8 $66 $33 $C0 $8B
              $C8 $3D $26 $01 $7D $35 $67 $26 $8B $34 $43 $D1 $E6 $8B $32 $67
              $3B $34 $45 $16 $5B $00 $00 $74 $13 $67 $89 $34 $45 $16 $5B $00
              $00 $67 $8B $3C $45 $C0 $35 $00 $00 $E8 $74 $FF $40 $41 $83 $F9
              $15 $7C $CE $33 $C9 $03 $1E $54 $56 $EB $C6 $CB $BA $2E $00 $66
              $33 $C0 $8B $C3 $66 $8B $D8 $66 $33 $C0 $8B $C8 $3D $26 $01 $7D
              $35 $67 $26 $8B $34 $43 $D1 $E6 $8B $32 $67 $3B $34 $45 $B8 $5D
              $00 $00 $74 $13 $67 $89 $34 $45 $B8 $5D $00 $00 $67 $8B $3C $45
              $C0 $35 $00 $00 $E8 $29 $FF $40 $41 $83 $F9 $15 $7C $CE $33 $C9
              $03 $1E $54 $56 $EB $C6 $CB
%patch $B7B2 $3911W #UpdateFarCall to ADT_0
%patch $B7AA $395CW #UpdateFarCall to ADT_1

#Colliding Butler Robots use new code
%patch $17CB $F000W

#New collision code
%patch $F000 $55 $8B $EC $8B $5E $06 $81 $3F $000AW  $74 $0E $81 $3F $0005W
             $75 $10 $C7 $06 $6C60W  $0001W  $EB $08 $8B $5E $04 $C7 $47 $2A
             $0000W  $5D $C3

###ITEMS###

#Lollipop points
%patch $15078 $01 $00

#Pizza points
%patch $15076 $0000W

#What we need before we can win
%patch $8020 $EB $1A #No parts

#Keen 3 scoring items backgrounds
%patch $4409      $26 $8B $07 $B6 $0D $F6 $FE 
%patch $4410  $F6 $EE $26 $89 $07 $E9 $60 $01 

%patch $4482  $E9 $74 $FF 
%patch $44BA  $E9 $3C $FF 
%patch $4513  $E9 $E3 $FE 

%patch $28EC                  $26 $8B $07 $B6 
%patch $28F0  $0D $F6 $FE $F6 $EE $26 $89 $07 
%patch $28F8  $03 $1E $08 $6C $03 $1E $08 $6C 
%patch $2900  $26 $89 $07 $90 $90 $90 $90 $90 

###CHEATS###

#Disable G O D cheat
%patch $120D $2C $50
%patch $1214 $2C $50
%patch $121B $2C $50

#What CTSpace cheat gives Keen
%patch $0E01 $AAC8W $0001W #1 shot

###ENDING###

#No black screen pause before ending sequence
%patch $820C $EB $07

#Level used for ending map
%patch $81CA  82

#Go directly from Mars map sequence to Endtext
%patch $8252 $E9 $067DW

#Ending map position
%patch $81D7 $30     #x position (x10)
%patch $81DD $00     #x position
%patch $81E3 $E0     #Y position (x10)
%patch $81E8 $01     #Y position

#How long Mars textbox waits
%patch $88D3 $0130W

#All text appears instantly
%patch $8172 $EB $07

%patch $8216 $0012W #Bottom
               
%patch $15C24 "DIE SONNE SCHEINT WIEDER AUF UNSERE" $0A $00
%patch $15C49 "        SCHOENE REPUBLIK!        " $0A $00
%patch $15C6C "" $0A $00
%patch $15C91 "" $00

#Don't show Keen on the map ending sequence
%patch $8203 $90 $90 $90


%end